package imie;

public class Data implements Comparable<Data>{
	private static final int[] MAX = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31,
			30, 31};
	private final int mm;
	private final int dd;

	public Data(int dd, int mm){
		if(concord(dd, mm)){
			this.mm = mm;
			this.dd = dd;
		}
		else{
			this.mm = -1;
			this.dd = -1;
		}
	}

	@Override
	public boolean equals(Object o) {
		if(this == o){
			return true;
		}
		if(o == null){
			return false;
		}
		if(getClass() != o.getClass()){
			return false;
		}
		Data temp = (Data)o;
		return ((getDd() == temp.getDd())) && (getMm() == temp.getMm());
	}

	@Override
	public int hashCode() {
		return 17 * Integer.valueOf(getDd()).hashCode() + 19
				* Integer.valueOf(getMm()).hashCode();
	}

	@Override
	public String toString() {
		return dd + "-" + mm;
	}

	public int getMm() {
		return mm;
	}

	public int getDd() {
		return dd;
	}

	private static boolean properDay(int data) {
		return !((data < 1) || (data > 31));
	}

	private static boolean properMonth(int data) {
		return !((data < 1) || (data > 12));
	}

	private static boolean concord(int dd, int mm) {
		if(properDay(dd) && properMonth(mm)){
			return (dd <= MAX[mm - 1]);
		}
		else{
			throw new IllegalArgumentException("zły miesiąc lub dzień");
		}
	}

	@Override
	public int compareTo(Data o) {
		if(mm > o.getMm()){
			return 1;
		}
		else if(mm < o.getMm()){
			return -1;
		}
		else{
			return Integer.compare(dd, o.getDd());
		}
	}
}
