package imie;

import java.util.*;

public class Imie implements Comparable<Imie>{
	private final String imie;
	private Data[] daty;

	public Imie(String imie, Data... daty){
		this.imie = imie;
		this.daty = daty;
		Arrays.sort(daty);
	}

	@Override
	public boolean equals(Object o) {
		if(this == o){
			return true;
		}
		if(o == null){
			return false;
		}
		if(getClass() != o.getClass()){
			return false;
		}
		Imie temp = (Imie)o;
		return ((getImie().equals(temp.getImie())))
				&& (Arrays.equals(getDaty(), temp.getDaty()));
	}

	@Override
	public int hashCode() {
		return 17 * getImie().hashCode() + 19 * Arrays.hashCode(getDaty());
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(imie);
		for(int i = 0; i < daty.length; i++){
			if(i < (daty.length) - 1){
				sb.append(" ");
				sb.append(daty[i]);
				sb.append(",");
			}
			else{
				sb.append(" ");
				sb.append(daty[i]);
			}
		}
		return sb.toString();
	}

	public String getImie() {
		return imie;
	}

	public Data[] getDaty() {
		return daty;
	}

	public void addDate(Data imieniny) {
		int ind = Arrays.binarySearch(daty, imieniny);
		if(ind == -1){
			int len = daty.length;
			daty = extendArray(daty);
			daty[len] = imieniny;
			Arrays.sort(daty);
		}
	}

	public void addDate(int day, int month) {
		Data imieniny = new Data(day, month);
		int ind = Arrays.binarySearch(daty, imieniny);
		if(ind == -1){
			int len = daty.length;
			daty = extendArray(daty);
			daty[len] = imieniny;
			Arrays.sort(daty);
		}
	}

	public void removeImieniny(Data imieniny) {
		int ind = Arrays.binarySearch(daty, imieniny);
		daty = shortenArray(daty, ind);
	}

	/**
	 * Przedluza tablice o 1 element
	 */
	public static <T> T[] extendArray(T[] tabl) {
		int len = tabl.length;
		return Arrays.copyOf(tabl, len + 1);
	}

	/**
	 * Skraca tablice o jeden usuwajac element o podanym indeksie
	 */
	public static <T> T[] shortenArray(T[] tabl, int indexDeleted) {
		int len = tabl.length;
		//sprawdza czy index miesci sie w tablicy
		if((indexDeleted > len - 1) || (indexDeleted < 0)){
			throw new IndexOutOfBoundsException("index poza tablicą");
		}
		else{//jesli tak
				//to przepisuje rekordy za indeksem o 1 w lewo
			for(int i = indexDeleted; i < tabl.length - 1; i++){
				tabl[i] = tabl[i + 1];
			}
		}
		//a nastepnie skraca tablice o 1
		return Arrays.copyOf(tabl, len - 1);
	}

	@Override
	public int compareTo(Imie o) {
		return getImie().compareTo(o.getImie());
	}
}
