package imie;

import java.io.*;
import java.text.*;
import java.util.*;

public class ImieninyUtil{
	private ImieninyUtil(){}

	public static String[] printImionaDlaDaty1(int dzien, int miesiac) {
		Imieniny imieniny = new Imieniny();
		ArrayList<Imie> al = imieniny.getImiona();
		ArrayList<String> al1 = new ArrayList<>();
		Data akt = new Data(dzien, miesiac);
		for (Imie imie : al) {
			String imie2 = imie.getImie();
			Data[] daty = imie.getDaty();
			for (Data data : daty) {
				if (data.equals(akt)) {
					al1.add(imie2);
				}
			}
		}
		Collections.sort(al1);
		int len = al1.size();
		String[] im = new String[len];
		for(int k = 0; k < len; k++){
			im[k] = al1.get(k);
		}
		return im;
	}

	public static String printImionaDlaDaty2(int dzien, int miesiac) {
		Imieniny imieniny = new Imieniny();
		ArrayList<Imie> al = imieniny.getImiona();
		ArrayList<String> al1 = new ArrayList<>();
		Data akt = new Data(dzien, miesiac);
		for (Imie imie : al) {
			String imie2 = imie.getImie();
			Data[] daty = imie.getDaty();
			for (Data data : daty) {
				if (data.equals(akt)) {
					al1.add(imie2);
				}
			}
		}
		Collections.sort(al1);
		int len = al1.size();
		StringBuilder im = new StringBuilder();
		for(int k = 0; k < len; k++){
			if(k < len - 1){
				im.append(al1.get(k));
				im.append(",");
			}
			else{
				im.append(al1.get(k));
			}
		}
		return im.toString();
	}

	public static void printImionamiTxt() {
		DateFormatSymbols symbols = new DateFormatSymbols();
		String[] monthNames = symbols.getMonths();
		try (PrintWriter pw = new PrintWriter("assets/imionami")) {
			pw.println("Hello World");
			Imieniny imieniny = new Imieniny();
			ArrayList<Imie> al = imieniny.getImiona();
			for (Imie imie : al) {
				String imie2 = imie.getImie();
				Data[] daty = imie.getDaty();
				Objects.requireNonNull(pw).print(imie2 + ": ");
				for (int j = 0; j < daty.length; j++) {
					pw.print(daty[j].getDd() + " "
							+ monthNames[daty[j].getMm() - 1]);
					if (j != daty.length - 1) {
						pw.print(", ");
					} else {
						pw.print(";");
					}
				}
				pw.println();
			}
		} catch (FileNotFoundException e){
			e.printStackTrace();
		}

	}

	public static void printImionamiHTML() {
		DateFormatSymbols symbols = new DateFormatSymbols();
		String[] monthNames = symbols.getMonths();
		PrintWriter pw = null;
		try{
			pw = new PrintWriter("assets/imionami.html");
		} catch (FileNotFoundException e){
			e.printStackTrace();
		}
		Imieniny imieniny = new Imieniny();
		ArrayList<Imie> al = imieniny.getImiona();
		Objects.requireNonNull(pw).println("<!DOCTYPE html>");
		pw.println("<html>");
		pw.println("<head>");
		pw.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
		pw.println("</head>");
		pw.println("<body>");
		pw.println("<div>");
		for (Imie imie : al) {
			String imie2 = imie.getImie();
			Data[] daty = imie.getDaty();
			pw.print("<p><b>" + imie2 + "</b>" + ": ");
			for (int j = 0; j < daty.length; j++) {
				pw.print(daty[j].getDd() + " "
						+ monthNames[daty[j].getMm() - 1]);
				if (j != daty.length - 1) {
					pw.print(", ");
				} else {
					pw.print("</p>");
				}
			}
			pw.println();
		}
		pw.println("</div>");
		pw.println("</body>");
		pw.println("</html>");
		pw.close();
	}
}
